io.vertx.grpc.stub

## Class GrpcWriteStream<T>

- java.lang.Object
- - io.vertx.grpc.stub.GrpcWriteStream<T>

- All Implemented Interfaces:
    StreamBase, WriteStream<T>

      public class GrpcWriteStream<T>
      extends Object
      implements WriteStream<T>

  Author:
    ecatala

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GrpcWriteStream(io.grpc.stub.StreamObserver<T> observer)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `WriteStream<T>` | `drainHandler(Handler<Void> hndlr)` Set a drain handler on the stream.
    `void` | `end(Handler<AsyncResult<Void>> hndlr)` Same as `WriteStream.end()` but with an `handler` called when the operation completes
    `WriteStream<T>` | `exceptionHandler(Handler<Throwable> hndlr)` Set an exception handler on the write stream.
    `WriteStream<T>` | `setWriteQueueMaxSize(int i)` Set the maximum size of the write queue to `maxSize`.
    `io.grpc.stub.StreamObserver<T>` | `streamObserver()` Low level control of the observer for advanced use cases.
    `Future<Void>` | `write(T data)` Write some data to the stream.
    `void` | `write(T data, Handler<AsyncResult<Void>> hndlr)` Same as `#write(T)` but with an `handler` called when the operation completes
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `WriteStream.setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, end, end`

- - ### Constructor Detail

    - #### GrpcWriteStream

          public GrpcWriteStream(io.grpc.stub.StreamObserver<T> observer)

  - ### Method Detail

    - #### exceptionHandler

          public WriteStream<T> exceptionHandler(Handler<Throwable> hndlr)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<T>`
      Parameters:
        `hndlr` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public Future<Void> write(T data)

      Description copied from interface: `WriteStream`
      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pipe`.

      When the `data` is moved from the queue to the actual medium, the returned `Future` will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### write

          public void write(T data,
                            Handler<AsyncResult<Void>> hndlr)

      Description copied from interface: `WriteStream`
      Same as `#write(T)` but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WriteStream<T>`

    - #### end

          public void end(Handler<AsyncResult<Void>> hndlr)

      Description copied from interface: `WriteStream`
      Same as `WriteStream.end()` but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<T>`

    - #### setWriteQueueMaxSize

          public WriteStream<T> setWriteQueueMaxSize(int i)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<T>`
      Parameters:
        `i` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeQueueFull

          public boolean writeQueueFull()

      Description copied from interface: `WriteStream`
      This will return `true` if there are more bytes in the write queue than the value set using `WriteStream.setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<T>`
      Returns:
        `true` if write queue is full

    - #### drainHandler

          public WriteStream<T> drainHandler(Handler<Void> hndlr)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<T>`
      Parameters:
        `hndlr` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### streamObserver

          public io.grpc.stub.StreamObserver<T> streamObserver()

      Low level control of the observer for advanced use cases.

Copyright © 2024 Eclipse. All rights reserved.